import React, {useEffect, useState} from "react";
export default function SonComponent2(props= {
    msg:"",
    changeMsg:(_)=>{}
}){
    const [state, setState] = useState({
        msg: "son msg",
        tmp: "",
        count: 0,
    })

    function changeMsg(){
        let target = `parent msg 被修改 (${++state.count})`
        setState({
            ...state,
            tmp: props.changeMsg(target)
        })
    }

    function revokeChangeMsg(){
        setState({
            ...state,
            // count: state.count > 0 ? --state.count : 0,
            tmp: props.changeMsg(state.tmp)
        })
    }


    return <div style={{border: '1px solid', width: '80%', overflow: 'auto'}}>
        子组件2

        <div style={{border: '1px solid', width: '80%', overflow: 'auto', margin: 'auto'}}>
            <div>
                {state.msg}
            </div>

            <hr/>

            <div>
                {props.msg}

                <div>
                    <button onClick={changeMsg}>修改msg</button>
                    <button onClick={revokeChangeMsg}>撤销操作</button>
                </div>
            </div>
        </div>
    </div>

}
